CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

ActiveX 开发指南

相关分类

EndTangent Property (ActiveX)

2023-1-3 17:13| 发布者: admin| 查看: 799| 评论: 0|来自: AutoCAD

摘要: 将样条的端切指定为方向矢量。

将样条的端切指定为方向矢量。

支持的平台:仅窗口

签名

工 务 局:

object.EndTangent
对象

类型:样条

此属性适用的对象。

属性值

只读:

类型:变体(双精度的三元素数组)

表示样条的端切的方向矢量。

言论

当样条升高时,它将从插值(拟合)样条转换为控制点样条。这意味着在高程之后,样条不再具有拟合切线,并且样条的和属性不再可访问。编辑控制点样条的唯一方法是通过属性或理论方法。StartTangentEndTangentControlPointsSetControlPointGetControlPoint

例子

工 务 局:

Sub Example_EndTangent()
    ' This example creates a spline. It then queries the current setting for
    ' the EndTangent, and then changes the EndTangent to a new value.

    ' Create the spline
    Dim splineObj As AcadSpline
    Dim startTan(0 To 2) As Double
    Dim endTan(0 To 2) As Double
    Dim fitPoints(0 To 8) As Double
    Dim msg As String
    
    startTan(0) = 0.5: startTan(1) = 0.5: startTan(2) = 0
    endTan(0) = 0.5: endTan(1) = 0.5: endTan(2) = 0
    fitPoints(0) = 1: fitPoints(1) = 1: fitPoints(2) = 0
    fitPoints(3) = 5: fitPoints(4) = 5: fitPoints(5) = 0
    fitPoints(6) = 10: fitPoints(7) = 0: fitPoints(8) = 0
    Set splineObj = ThisDrawing.ModelSpace.AddSpline(fitPoints, startTan, endTan)
    
    ZoomAll
    GoSub GETPOINTS
    MsgBox "The EndTangent for the spline is " & msg, vbInformation, "EndTangent Example"

    ' Change the end tangent of Spline to (1.5,0.707,2)
    Dim newTan(0 To 2) As Double
    newTan(0) = 1.5: newTan(1) = 0.707: newTan(2) = 2
    splineObj.EndTangent = newTan

    ThisDrawing.Regen True
    GoSub GETPOINTS
    MsgBox "The EndTangent has been changed to " & msg, vbInformation, "EndTangent Example"

    Exit Sub

GETPOINTS:
    msg = ""
    ' Get the coordinates from the end tangent
    Dim count As Integer
    For count = 0 To 2
        msg = msg & Format(splineObj.EndTangent(count), "0.###") & ", "
    Next
    msg = VBA.Left(msg, Len(msg) - 2)
    Return
End Sub

Visual LISP:

(vl-load-com)
(defun c:Example_EndTangent()
    ;; This example creates a spline. It then queries the current setting for
    ;; the EndTangent, and then changes the EndTangent to a new value.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))
  
    ;; Create the spline
    (setq startTan (vlax-3d-point 0.5 0.5 0)
          endTan (vlax-3d-point 0.5 0.5 0)
          fitPoints (vlax-make-safearray vlax-vbDouble '(0 . 8)))
    (vlax-safearray-fill fitPoints '(1 1 0
				     5 5 0
				     10 0 0
				    )
    )
    
    ;; Create the spline
    (setq modelSpace (vla-get-ModelSpace doc))
    (setq splineObj (vla-AddSpline modelSpace fitPoints startTan endTan))

    (vla-ZoomAll acadObj)

    (setq msg "")

    ;; Get the coordinates from the end tangent
    (setq endTangent (vlax-safearray->list (vlax-variant-value (vla-get-EndTangent splineObj))))
    (setq msg (strcat msg (rtos (nth 0 endTangent) 2 3) ","
		          (rtos (nth 1 endTangent) 2 3) ","
		          (rtos (nth 2 endTangent) 2 3)))

    (alert (strcat "The EndTangent for the spline is " msg))

    ;; Change the end tangent of Spline to (1.5,0.707,2)
    (setq newTan (vlax-3d-point 1.5 0.707 2))
    (vla-put-EndTangent splineObj newTan)

    (vla-Regen doc :vlax-true)

    (setq msg "")
    (setq endTangent (vlax-safearray->list (vlax-variant-value (vla-get-EndTangent splineObj))))
    (setq msg (strcat msg (rtos (nth 0 endTangent) 2 3) ","
		          (rtos (nth 1 endTangent) 2 3) ","
		          (rtos (nth 2 endTangent) 2 3)))

    (alert (strcat "The EndTangent has been changed to " msg))
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-5-11 18:51

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部